blob: 08da171e858ef7dd0753be8383e2e28017e734f7 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
20while [ -h "${prog}" ]; do
21 newProg=`/bin/ls -ld "${prog}"`
22 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
23 if expr "x${newProg}" : 'x/' >/dev/null; then
24 prog="${newProg}"
25 else
26 progdir=`dirname "${prog}"`
27 prog="${progdir}/${newProg}"
28 fi
29done
30oldwd=`pwd`
31progdir=`dirname "${prog}"`
32cd "${progdir}"
33progdir=`pwd`
34prog="${progdir}"/`basename "${prog}"`
35
36export JAVA="java"
37export JAVAC="javac -target 1.5"
38export RUN="${progdir}/etc/push-and-run-test-jar"
39
40info="info.txt"
41build="build"
42run="run"
43expected="expected.txt"
44output="output.txt"
45build_output="build-output.txt"
46run_args="--quiet"
47
48dev_mode="no"
49update_mode="no"
50debug_mode="no"
51usage="no"
52
53while true; do
54 if [ "x$1" = "x--host" ]; then
55 RUN="${progdir}/etc/host-run-test-jar"
56 shift
57 elif [ "x$1" = "x--reference" ]; then
58 RUN="${progdir}/etc/reference-run-test-classes"
59 shift
Elliott Hughes7c046102011-10-19 18:16:03 -070060 elif [ "x$1" = "x-d" ]; then
61 run_args="${run_args} -d"
62 shift
jeffhao5d1ac922011-09-29 17:41:15 -070063 elif [ "x$1" = "x--debug" ]; then
64 run_args="${run_args} --debug"
65 shift
66 elif [ "x$1" = "x--gdb" ]; then
67 run_args="${run_args} --gdb"
68 dev_mode="yes"
69 shift
70 elif [ "x$1" = "x--zygote" ]; then
71 run_args="${run_args} --zygote"
72 shift
73 elif [ "x$1" = "x--no-verify" ]; then
74 run_args="${run_args} --no-verify"
75 shift
76 elif [ "x$1" = "x--no-optimize" ]; then
77 run_args="${run_args} --no-optimize"
78 shift
79 elif [ "x$1" = "x--no-precise" ]; then
80 run_args="${run_args} --no-precise"
81 shift
Elliott Hughes7c046102011-10-19 18:16:03 -070082 elif [ "x$1" = "x--invoke-with" ]; then
83 shift
84 what="$1"
85 run_args="${run_args} --invoke-with \"${what}\""
jeffhao5d1ac922011-09-29 17:41:15 -070086 shift
87 elif [ "x$1" = "x--dev" ]; then
88 run_args="${run_args} --dev"
89 dev_mode="yes"
90 shift
91 elif [ "x$1" = "x--update" ]; then
92 update_mode="yes"
93 shift
94 elif [ "x$1" = "x--help" ]; then
95 usage="yes"
96 shift
97 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -070098 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -070099 usage="yes"
100 break
101 else
102 break
103 fi
104done
105
106if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
107 echo "--dev and --update are mutually exclusive" 1>&2
108 usage="yes"
109fi
110
111if [ "$usage" = "no" ]; then
112 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
113 test_dir=`basename "$oldwd"`
114 else
115 test_dir="$1"
116 fi
117
118 if [ '!' -d "$test_dir" ]; then
119 td2=`echo ${test_dir}-*`
120 if [ '!' -d "$td2" ]; then
121 echo "${test_dir}: no such test directory" 1>&2
122 usage="yes"
123 fi
124 test_dir="$td2"
125 fi
126
127 # Shift to get rid of the test name argument. The rest of the arguments
128 # will get passed to the test run.
129 shift
130fi
131
132if [ "$usage" = "yes" ]; then
133 prog=`basename $prog`
134 (
135 echo "usage:"
136 echo " $prog --help Print this message."
137 echo " $prog [options] [test-name] Run test normally."
138 echo " $prog --dev [options] [test-name] Development mode" \
139 "(dumps to stdout)."
140 echo " $prog --update [options] [test-name] Update mode" \
141 "(replaces expected.txt)."
142 echo ' Omitting the test name or specifying "-" will use the' \
143 "current directory."
144 echo " Runtime Options:"
jeffhao5d1ac922011-09-29 17:41:15 -0700145 echo " --debug Wait for a debugger to attach."
146 #echo " --gdb Run under gdb; incompatible with some tests."
147 echo " --no-verify Turn off verification (on by default)."
148 echo " --no-optimize Turn off optimization (on by default)."
149 echo " --no-precise Turn off precise GC (on by default)."
150 echo " --zygote Spawn the process from the Zygote." \
151 "If used, then the"
152 echo " other runtime options are ignored."
153 echo " --host Use the host-mode virtual machine."
154 echo " --valgrind Use valgrind when running locally."
155 echo " --reference Use a host-local reference virtual machine."
156 ) 1>&2
157 exit 1
158fi
159
160cd "$test_dir"
161test_dir=`pwd`
162
163td_info="${test_dir}/${info}"
164td_expected="${test_dir}/${expected}"
165
166tmp_dir="/tmp/test-$$"
167
168if [ '!' '(' -r "$td_info" -a -r "$td_expected" ')' ]; then
169 echo "${test_dir}: missing files" 1>&2
170 exit 1
171fi
172
173# copy the test to a temp dir and run it
174
Elliott Hughes510c8782011-10-06 10:57:34 -0700175echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700176
177rm -rf "$tmp_dir"
178cp -Rp "$test_dir" "$tmp_dir"
179cd "$tmp_dir"
180
181if [ '!' -r "$build" ]; then
182 cp "${progdir}/etc/default-build" build
183fi
184
Elliott Hughes510c8782011-10-06 10:57:34 -0700185echo "${test_dir}: running..." 1>&2
186
jeffhao5d1ac922011-09-29 17:41:15 -0700187if [ '!' -r "$run" ]; then
188 cp "${progdir}/etc/default-run" run
189fi
190
191chmod 755 "$build"
192chmod 755 "$run"
193
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700194export TEST_NAME=`basename ${test_dir}`
195
jeffhao5d1ac922011-09-29 17:41:15 -0700196good="no"
197if [ "$dev_mode" = "yes" ]; then
198 "./${build}" 2>&1
199 echo "build exit status: $?" 1>&2
200 "./${run}" $run_args "$@" 2>&1
201 echo "run exit status: $?" 1>&2
202 good="yes"
203elif [ "$update_mode" = "yes" ]; then
204 "./${build}" >"$build_output" 2>&1
205 build_exit="$?"
206 if [ "$build_exit" = '0' ]; then
207 "./${run}" $run_args "$@" >"$output" 2>&1
208 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
209 good="yes"
210 else
211 cat "$build_output" 1>&2
212 echo "build exit status: $build_exit" 1>&2
213 fi
214else
215 "./${build}" >"$build_output" 2>&1
216 build_exit="$?"
217 if [ "$build_exit" = '0' ]; then
218 "./${run}" $run_args "$@" >"$output" 2>&1
219 else
220 cp "$build_output" "$output"
221 echo "build exit status: $build_exit" >>"$output"
222 fi
223 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
224 if [ "$?" = "0" ]; then
225 # output == expected
226 good="yes"
227 echo "${test_dir}: succeeded!" 1>&2
228 fi
229fi
230
231if [ "$good" = "yes" ]; then
232 cd "$oldwd"
233 rm -rf "$tmp_dir"
234 exit 0
235fi
236
237(
238 if [ "$update_mode" '!=' "yes" ]; then
239 echo "${test_dir}: FAILED!"
240 echo ' '
241 echo '#################### info'
242 cat "${td_info}" | sed 's/^/# /g'
243 echo '#################### diffs'
244 diff --strip-trailing-cr -u "$expected" "$output"
245 echo '####################'
246 echo ' '
247 fi
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700248 echo "${TEST_NAME} files left in ${tmp_dir}"
jeffhao5d1ac922011-09-29 17:41:15 -0700249) 1>&2
250
251exit 1